<template>
  <q-list style="background-color: #fff">
    <q-item
      v-for="search in history"
      :key="search.timestamp"
      clickable
      v-ripple
      @click="doSearch(search)"
    >
      <q-item-section>
        <q-item-label class="lh-search-meta self-start">
          <img src="/imgs/search.svg" alt="Search icon"/>
          &nbsp;{{ lhDateFormat(search.timestamp) }}
          &nbsp;
          <span color="#b375ff">•</span>
          &nbsp;
          {{ search.src.name }}
        </q-item-label>
        <q-item-label class="This-is-the-thing-I self-start">
          {{ formattedSearchTerm(search) }}
        </q-item-label>
      </q-item-section>
      <q-item-section
        side
        @click.stop="removeSearch(search)"
        class="trashmargin"
      >
        <img src="/imgs/trash-it.svg" alt="Delete icon"/>
      </q-item-section>
    </q-item>
  </q-list>
</template>

<script>
import { date } from "quasar";
import { mapActions, mapGetters } from "vuex";

export default {
  computed: {
    ...mapGetters({
      history: "search/userSearchHistory",
    }),
  },
  methods: {
    ...mapActions({
      removeSearch: "search/removeSearch",
      addSearch: "search/addSearch",
    }),
    formattedSearchTerm(search) {
      let st = search.searchTerm;
      if (st.length >= 80) {
        return st.substring(0, 77).concat("...");
      } else {
        return st;
      }
    },
    lhDateFormat(ts) {
      return date.formatDate(ts, "MM/DD/YYYY HH:MM:SS a");
    },
    doSearch(search) {
      if (this.$router.page !== "app") {
        this.$router.push("/app/search");
      }
      this.addSearch({
        timestamp: Date.now(),
        src: search.src,
        searchTerm: search.searchTerm,
      });
    },
  },
};
</script>

<style scoped>
.lh-search-meta {
  height: 14px;
  font-size: 11px;
  font-weight: normal;
  font-style: normal;
  font-stretch: normal;
  line-height: normal;
  letter-spacing: normal;
  color: #7a767f;
  margin-top: 8px;
  margin-left: 10px;
}
.This-is-the-thing-I {
  height: 18px;
  font-size: 14px;
  font-weight: normal;
  font-style: normal;
  font-stretch: normal;
  line-height: normal;
  letter-spacing: normal;
  color: #27261e;
  margin-left: 10px;
}
.trashmargin {
  margin-right: 10px;
}
</style>
